<?php 
    /*Feito por Victor Rangel
    Produto Odhen*/
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\Manager;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Services;
use Zeedhi\Framework\DataSource\DataSet;

class DispositivoSSL extends CrudWithParameterBag { 
    
    protected $dataSourceName = 'dispositivoSSL';
    protected $parameterBagColumns = array('NRORG', "CDFILIAL", "CDCAIXA");
    
    public function __construct ($crudService, $parameterBag, Manager $dataSourceManager, Utilities\Util $utilService, Services\DispositivoSSLService $dispSSLService) {
        $this->parameterBag             = $parameterBag;
        $this->dataSourceManager        = $dataSourceManager;
        $this->dataSourceManager        = $dataSourceManager;
        $this->utilService              = $utilService;
        $this->dispSSLService           = $dispSSLService;
    }
    
    ///save's
    public function save(DTO\Request\DataSet $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceName;
        $this->parameterBagColumns = $this->parameterBagColumns;
        self::saveCrud($request, $response);
    }
    
    ///delete's
    public function delete(DTO\Request\DataSet $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceName;
        $this->parameterBagColumns = $this->parameterBagColumns;
        self::deleteCrud($request, $response);
    }
    
    public function verificaSSL(DTO\Request\Row $request, DTO\Response $response) {
        
        try {
            $conditions = $this->utilService->getParamsAsArray($request);
        
            $params = array(
                ':CDFILIAL' => $conditions['CDFILIAL']
            );
            
            $resultado = $this->dispSSLService->verificaSSL($params);
            $response->addDataSet(new DataSet($this->dataSourceName, $resultado));
        } catch (\Exception $e) {
            $response->setCriticalError(new DTO\Response\Error('Verifique se o Tipo SSL foi parametrizado na tela de Parametros de Unidade', $e->getCode(), $e->getTraceAsString()));
        }
        
    }
    
    public function verificaCodigo(DTO\Request\Row $request, DTO\Response $response) {
        $conditions = $this->utilService->getParamsAsArray($request);
        
        $params = array(
            ':IDSERIALDISP' => $conditions['IDSERIALDISP'],
            ':IDCODSSL'     => $conditions['IDCODSSL']
        );
        
        $resultado = $this->dispSSLService->verificaCodigo($params);
        $response->addDataSet(new DataSet('contaRegistros', $resultado));
    }
    
    public function deleteCrud(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $deletedRows = $this->dataSourceManager->delete($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $deletedRows));
        } catch (\Exception $e) {
            $response->setCriticalError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
    public function saveCrud(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $persistedRows = $this->dataSourceManager->persist($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
        } catch (\Exception $e) {
            $response->setCriticalError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
}
?>