<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelMTCMovProd {

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
  
    public function find($conditions, $DTINI, $DTFIN, $MTCUNID) {
        $params = array(
            ":CDFILIAL" => $conditions['CDFILIAL'],
            ":MTCUNID" => $MTCUNID,
            ":DTINI" => $DTINI,
            ":DTFIN" => $DTFIN,
            ":NRORG" => $conditions['NRORG'],
            ':TCDPRODUTO' => $conditions['TCDPRODUTO'],
            ':CDPRODLIST' => $conditions['CDPRODLIST'],
            ':CDARVPRODF' => $conditions['CDARVPRODF'],
            ':CDARVPRODI' => $conditions['CDARVPRODI'],
            ':CDNVPRODUTOAGRUP' => $conditions['CDNVPRODUTOAGRUP'],
            ':PRODNIV' => $conditions['PRODNIV']
        );
        return $this->entityManager->getConnection()->fetchAll(self::GET_MTC_PER_PROD, $params);
    }
  
    public function findMTCUNIT($NRORG, $CDFILIAL, $DTINI, $DTFIN) {
        $params = array(
            ":CDFILIAL" => $CDFILIAL,
            ":DTINI" => $DTINI,
            ":DTFIN" => $DTFIN,
            ":NRORG" => $NRORG
        );
        return $this->entityManager->getConnection()->fetchAll(self::GET_MTC_UNIDADE, $params);
    }
    
    const GET_MTC_PER_PROD = "
        SELECT ROWNUM RANK, X.* 
          FROM (  SELECT I.CDFILIAL||' - '||F.NMFILIAL AS LABELFILIAL, P.CDARVPROD||' - '||P.NMPRODUTO AS LABELPROD, P.CDARVPROD, I.CDPRODUTO, P.NMPRODUTO, P.SGUNIDADE, ROUND(SUM(I.VRUNITVEND * I.QTPRODVEND)/SUM(I.QTPRODVEND),2) AS UNITMED, SUM(I.QTPRODVEND) AS QTD, 
                         SUM(((I.VRUNITVEND + NVL(I.VRUNITVENDCL,0))*(I.QTPRODVEND))-(NVL(I.VRDESITVEND,0)) + (NVL(I.VRACRITVEND,0))) AS VALORTOTAL,
                         ROUND(((SUM(I.QTPRODVEND)/NVL(:MTCUNID,1))*1000),3) AS MTC, PV.CDARVPROD||' - '||PV.NMPRODUTO AS LABELPRODAVO
                    FROM ITEMVENDA I
                    JOIN PRODUTO P
                      ON I.CDPRODUTO = P.CDPRODUTO
                     AND I.NRORG = P.NRORG 
                    JOIN FILIAL F
                      ON I.CDFILIAL = F.CDFILIAL
                     AND I.NRORG = F.NRORG
                     JOIN PRODUTO PV
                      ON P.NRORG = PV.NRORG
                   WHERE I.CDFILIAL = :CDFILIAL
                     AND TRUNC(I.DTHRPEDIDO) BETWEEN :DTINI AND :DTFIN
                     AND I.NRORG = :NRORG
                     AND P.CDPRODUTO LIKE PV.CDPRODUTO||'%'
                     AND PV.CDNVPRODUTO = :CDNVPRODUTOAGRUP
                     AND ((((INSTR(:CDPRODLIST, P.CDPRODUTO) > 0 ) OR (P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF ))) OR (P.CDARVPROD LIKE :PRODNIV) OR (:TCDPRODUTO = 'T')) 
                   GROUP BY P.CDARVPROD, I.CDPRODUTO, P.NMPRODUTO, P.SGUNIDADE, I.CDFILIAL, F.NMFILIAL, PV.NMPRODUTO, PV.CDARVPROD
                   ORDER BY 9 DESC
               ) X
    ";
    
    const GET_MTC_UNIDADE = "
        SELECT COUNT(V.NRSEQVENDA) AS MTC 
          FROM VENDA V 
         WHERE V.CDFILIAL = :CDFILIAL
           AND TRUNC(V.DTENTRVENDA) BETWEEN :DTINI AND :DTFIN
           AND V.NRORG = :NRORG
           AND V.IDSITUVENDA = 'O'
    ";
}